<template>
  <v-container>
    <v-card class="contenido">
      <v-text-field placeholder="Buscar Ubicación" id="search"> </v-text-field>
    </v-card>

    <v-card id="map"></v-card>

    <!-------------------------------DATOS DEL MAPA--------------------------------------------------------->
    <v-card id="information">
      <v-card-text>
        <p class="text-h4 text--primary">Detalles</p>
        <div class="text--primary">
          <h3>Resultado</h3>
          <ul>
            <li><strong>Dirección:</strong> <span id="location"></span></li>
            <li><strong>País:</strong> <span id="country"></span></li>
            <li><strong>Latitud:</strong> <span id="lat"></span></li>
            <li><strong>Longitud:</strong> <span id="lon"></span></li>
          </ul>
        </div>
      </v-card-text>
    </v-card>
    <!--
    <v-card class="infoPoligono">
      <h4>Coordenadas (X,Y) actualizadas</h4>
      <div
        id="info"
        style="
          position: absolute;
          color: red;
          font-family: Arial;
          height: 200px;
          font-size: 12px;
        "
      ></div>
    </v-card>
    -->

    <!---------------------------------------------------------------------------------------------------->
  </v-container>
</template>

<script>
import { Loader } from "google-maps";
const options = { libraries: ["drawing", "places"] };
const loader = new Loader("AIzaSyBD7Rmh9dkpF8wpYcaVA7obVdYyPm8ODPw", options);

export default {
  name: "GoogleMaps",

  mounted: async function () {
    const google = await loader.load();
    const map = new google.maps.Map(document.getElementById("map"), {

      //TOMAR DIRECCIÓN EXACTA DEL GPS
      center: { lat: -33.4432, lng: -70.6574 },
      zoom: 15,
    });

    //add autocomplete

    this.search(map, google);
    // this.autocomplete(map, google);

    // add drawing menu
    const drawingManager = new google.maps.drawing.DrawingManager({
      drawingControl: true,
      drawingControlOptions: {
        position: google.maps.ControlPosition.TOP_CENTER,
        drawingModes: [
          google.maps.drawing.OverlayType.POLYGON,
          google.maps.drawing.OverlayType.RECTANGLE,
        ],
      },
      polygonOptions: {
        clickable: true,
        draggable: true,
        editable: true,
        fillColor: "#ADFF2F",
        fillOpacity: 0.5,
      },
    });
    drawingManager.setMap(map);


    //this.completePolygon(google, drawingManager);
  },
  data: () => ({
    markers: [],
    places: [],
    currentPlace: {},
    coordinates: [],
  }),

  methods: {
    addAutocomplete(google) {
      return new google.maps.places.Autocomplete(
        document.getElementById("search")
      );
    },

    getPolygonCoords(newShape) {
      this.coordinates.splice(0, this.coordinates.length);
      let len = newShape.getPath().getLength();
      console.log(newShape.getPath());
      for (let i = 0; i < len; i++) {
        this.coordinates.push(newShape.getPath().getAt(i).toUrlValue(6));
      }

      console.log(this.coordinates);
      return this.coordinates;
    },

    completePolygon(google, drawingManager) {
      google.maps.event.addListener(
        drawingManager,
        "polygoncomplete",
        function (event) {
          event.getPath().getLength();
          google.maps.event.addListener(
            event,
            "dragend",
            this.getPolygonCoords(event)
          );

          google.maps.event.addListener(
            event.getPath(),
            "insert_at",
            function () {
              this.getPolygonCoords(event);
              console.log(this.getPolygonCoords(event));
            }
          );

          google.maps.event.addListener(event.getPath(), "set_at", function () {
            this.getPolygonCoords(event);
          });
        }
      );
    },

    search(map, google) {
      const autocomplete = this.addAutocomplete(google);
      autocomplete.bindTo("bounds", map);

      let infowindow = new google.maps.InfoWindow();
      let marker = new google.maps.Marker({
        map: map,
        anchorPoint: new google.maps.Point(0, -29),
      });

      autocomplete.addListener("place_changed", function () {
        infowindow.close();
        marker.setVisible(false);
        var place = autocomplete.getPlace();
        if (!place.geometry) {
          window.alert("Autocomplete's returned place contains no geometry");
          return;
        }

        // If the place has a geometry, then present it on a map.
        if (place.geometry.viewport) {
          map.fitBounds(place.geometry.viewport);
        } else {
          map.setCenter(place.geometry.location);
          map.setZoom(17);
        }
        marker.setIcon({
          url: place.icon,
          size: new google.maps.Size(71, 71),
          origin: new google.maps.Point(0, 0),
          anchor: new google.maps.Point(17, 34),
          scaledSize: new google.maps.Size(35, 35),
        });
        marker.setPosition(place.geometry.location);
        marker.setVisible(true);

        var address = "";
        if (place.address_components) {
          address = [
            (place.address_components[0] &&
              place.address_components[0].short_name) ||
              "",
            (place.address_components[1] &&
              place.address_components[1].short_name) ||
              "",
            (place.address_components[2] &&
              place.address_components[2].short_name) ||
              "",
          ].join(" ");
        }

        infowindow.setContent(
          "<div><strong>" + place.name + "</strong><br>" + address
        );
        infowindow.open(map, marker);

        // Location details
        for (var i = 0; i < place.address_components.length; i++) {
          if (place.address_components[i].types[0] == "postal_code") {
            document.getElementById("postal_code").innerHTML =
              place.address_components[i].long_name;
          }
          if (place.address_components[i].types[0] == "country") {
            document.getElementById("country").innerHTML =
              place.address_components[i].long_name;
          }
        }
        document.getElementById("location").innerHTML = place.formatted_address;
        document.getElementById("lat").innerHTML =
          place.geometry.location.lat();
        document.getElementById("lon").innerHTML =
          place.geometry.location.lng();
      });
    },
  },
};
</script>

<style scoped>
#map {
  position: absolute;
  left: 33%;
  width: 40%;
  height: 50%;
  right: 0;
  top: 100px;
}

#search {
  position: absolute;
  width: 20%;
  height: 50%;
}

.contenido {
  position: absolute;
  left: 20px;
  width: 72%;
  height: 80%;
}

.infoPoligono {
  position: absolute;
  left: 33%;
  top: 480px;
  width: 40%;
  height: 10%;
}

#information {
  position: absolute;
  top: 100px;
  left: 25px;
  width: 25%;
  height: 50%;
}
</style>
